<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:param name="PAGE_THEME_PATH" />
<xsl:param name="PAGE_WEB_PATH" />

<xsl:output method="html" encoding="utf-8" standalone="no" indent="no" omit-xml-declaration="yes" /> 

<xsl:template match="sitemap">
  <div class="navigation">
    <xsl:if test="count(mapitem) &gt; 0">
      <ul>
        <xsl:for-each select="mapitem">
          <xsl:call-template name="mapitem">
            <xsl:with-param name="indent" select="0"/>
          </xsl:call-template>
        </xsl:for-each>
      </ul>
    </xsl:if>
  </div>
</xsl:template>

<xsl:template name="mapitem">
  <xsl:param name="indent"/>  
  <xsl:variable name="classname">
    <xsl:choose>
      <xsl:when test="@focus">active</xsl:when>
      <xsl:when test=".//@focus">selected</xsl:when>
      <xsl:otherwise></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>    
  <li><xsl:if test="@focus"><xsl:attribute name="class">active</xsl:attribute></xsl:if>
    <a href="{@href}"><xsl:if test="@focus"><xsl:attribute name="class">active</xsl:attribute></xsl:if><xsl:value-of select="@title" disable-output-escaping="yes" /></a>
    <xsl:if test="count(mapitem) &gt; 0">
      <ul>
        <xsl:for-each select="mapitem">
          <xsl:call-template name="mapitem">
            <xsl:with-param name="indent" select="$indent + 1"/>
          </xsl:call-template>
        </xsl:for-each>
      </ul>
    </xsl:if>
  </li>
</xsl:template>

</xsl:stylesheet>

