<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="content_register">
  <xsl:variable name="dialog" select="/page/content/topic/registerpage/newdlg/dialog"/>
  <xsl:variable name="registerpage" select="/page/content/topic/registerpage"/>
  
  <h1><xsl:value-of select="/page/content/topic/title"/></h1>
  
  <xsl:if test="$registerpage/error">
    <div class="loginMessage">
      <xsl:value-of select="$registerpage/error"/>
    </div>
  </xsl:if>
  <xsl:if test="$registerpage/success">
    <div class="loginMessage">
      <xsl:value-of select="$registerpage/success"/>
    </div>
  </xsl:if>
  
  <xsl:if test="$dialog">
  <br/>  
  
  <form class="registration" action="{$dialog/@action}" method="post">
  <xsl:copy-of select="$dialog/input[@type='hidden']"/>
  <table> 
    <tr>
      <td class="title">
        <xsl:value-of select="$dialog/lines/line[@fid='surfer_handle']/@caption"/>:
        <xsl:call-template name="forminputerror">
          <xsl:with-param name="error" select="$dialog/lines/line[@fid='surfer_handle']/@error"/>
        </xsl:call-template></td>
      <td class="inputField"><xsl:copy-of select="$dialog/lines/line[@fid='surfer_handle']/input"/></td>
    </tr>
    <tr>
      <td class="title"><xsl:value-of select="$dialog/lines/line[@fid='surfer_givenname']/@caption"/>:
        <xsl:call-template name="forminputerror">
          <xsl:with-param name="error" select="$dialog/lines/line[@fid='surfer_givenname']/@error"/>
        </xsl:call-template></td>
      <td class="inputField"><xsl:copy-of select="$dialog/lines/line[@fid='surfer_givenname']/input"/></td>
    </tr>
    <tr>  
      <td class="title"><xsl:value-of select="$dialog/lines/line[@fid='surfer_surname']/@caption"/>:
        <xsl:call-template name="forminputerror">
          <xsl:with-param name="error" select="$dialog/lines/line[@fid='surfer_surname']/@error"/>
        </xsl:call-template></td>
      <td class="inputField"><xsl:copy-of select="$dialog/lines/line[@fid='surfer_surname']/input"/></td>
    </tr>
    <tr>
      <td class="title"><xsl:value-of select="$dialog/lines/line[@fid='surfer_password_1']/@caption"/>:
        <xsl:call-template name="forminputerror">
          <xsl:with-param name="error" select="$dialog/lines/line[@fid='surfer_password_1']/@error"/>
        </xsl:call-template></td>
      <td class="inputField"><xsl:copy-of select="$dialog/lines/line[@fid='surfer_password_1']/input"/></td>
    </tr>
    <tr>  
      <td class="title"><xsl:value-of select="$dialog/lines/line[@fid='surfer_password_2']/@caption"/>:
        <xsl:call-template name="forminputerror">
          <xsl:with-param name="error" select="$dialog/lines/line[@fid='surfer_password_2']/@error"/>
        </xsl:call-template></td>
      <td class="inputField"><xsl:copy-of select="$dialog/lines/line[@fid='surfer_password_2']/input"/></td>
    </tr>        
    <tr>
      <td class="title"><xsl:value-of select="$dialog/lines/line[@fid='surfer_email_1']/@caption"/>:
        <xsl:call-template name="forminputerror">
          <xsl:with-param name="error" select="$dialog/lines/line[@fid='surfer_email_1']/@error"/>
        </xsl:call-template></td>
      <td class="inputField"><xsl:copy-of select="$dialog/lines/line[@fid='surfer_email_1']/input"/></td>
    </tr>
    <tr>  
      <td class="title"><xsl:value-of select="$dialog/lines/line[@fid='surfer_email_2']/@caption"/>:
        <xsl:call-template name="forminputerror">
          <xsl:with-param name="error" select="$dialog/lines/line[@fid='surfer_email_2']/@error"/>
        </xsl:call-template></td>
      <td class="inputField"><xsl:copy-of select="$dialog/lines/line[@fid='surfer_email_2']/input"/></td>
    </tr>                
  </table>    
    <div>
      <input class="submitButton" type="submit" value="Speichern"/>
    </div>
  </form>
  </xsl:if>  
</xsl:template>

</xsl:stylesheet>