<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="content_userdata">
  <xsl:param name="content" select="/page/content/topic"/>
  <h1>User Daten</h1>
  <div class="userDataName">
    <xsl:value-of select="$content/userdata/handle" />
  </div>
  <table class="userData">
    <tr>
      <td class="title">Name:</td>
      <td class="data"><xsl:value-of select="$content/userdata/name" /></td>
    </tr>
    <tr>
      <td class="title">Phone:</td>
      <td class="data"><xsl:value-of select="$content/userdata/phone" /></td>    
    </tr>
    <tr>
      <td class="title">Gruppe:</td>
      <td class="data"><xsl:value-of select="$content/userdata/group" /></td>
    </tr>
 </table>
 <xsl:choose>
    <xsl:when test="$content/userdata/dialog">
      <h2 class="userDataFormTitle">Nachricht schicken</h2>
      <xsl:if test="$content/userdata/message">
        <div class="userDataFormMessage">
          <xsl:value-of select="$content/userdata/message" />
        </div>
      </xsl:if>
      <xsl:call-template name="content_userdata_message_form">
        <xsl:with-param name="content" select="$content"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:when test="$content/userdata/message">
      <div class="userDataFormMessage">
        <xsl:value-of select="$content/userdata/message" />
      </div>
    </xsl:when>
 </xsl:choose>
  
</xsl:template>

<xsl:template name="content_userdata_message_form">
  <xsl:param name="content" />
  <xsl:param name="dialog" select="$content/userdata/dialog" />
  <form name="{$content/userdata/dialog/@title}" action="{$content/userdata/dialog/@action}">
    <xsl:copy-of select="$dialog/input[@type='hidden']"/>
    <table class="userDataSendMessage" border="0">
      <tr>
        <td class="title">Subject:</td>
        <td class="input">
          <xsl:copy-of select="$dialog/lines/line[@fid='subject']/input[@type='text']"/>
        </td>
      </tr>
      <tr>
        <td class="title">Message:</td>
        <td class="input">
          <xsl:copy-of select="$dialog/lines/line[@fid='text']/textarea"/>
        </td>
      </tr>
    </table>
    <input class="userDataSendMessageSubmitbutton" type="submit"  value="Abschicken" />
  </form>
</xsl:template>


</xsl:stylesheet>