<?php
/**
* Action box for Category teaser with thumbnail
*
* Zeigt den Teaser der ersten Unterseite einer Kategorie an mit Thumbnail.
*
* @package module_default
* @author Martin Kelm <kelm@papaya-cms.com>
* @version $Id: actbox_categteaserthumb.php,v 1.3 2006/05/26 14:41:18 weinert Exp $
*/

/**
* Basic class Action box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');
/**
* Action box for Category teaser with thumbnail
*
* Zeigt den Teaser der ersten Unterseite einer Kategorie an mit Thumbnail.
*
* @author Martin Kelm <kelm@papaya-cms.com>
* @package module_default
*/
class actionbox_categteaserthumb extends base_actionbox {

  var $editFields = array(
    'page'=>array ('Page', 'isNum', TRUE, 'input', 5, '', '0'),
    'count'=>array ('Count', 'isNum', TRUE, 'input', 5, '', 1),
    'sort'=>array ('Sort', 'isNum', TRUE, 'combo', array(0=>'Ascending', 1=>'Descending')),
    'Thumbnails',
    'thumbwidth'=>array ('Width', 'isNum', TRUE, 'input', 5, '', 100),
    'thumbheight'=>array ('Height', 'isNum', TRUE, 'input', 5, '', 100),
    'resizemode'=>array ('Resize mode', 'isAlpha', TRUE, 'combo',
      array('max'=>'Maximal', 'min'=>'Minimum', 'mincrop'=>'Minimum crop', 'abs'=>'Absolute'), '', 'max')
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    $result = '';
    include_once(PAPAYA_INCLUDE_PATH.'system/base_topiclist.php');
    $topicList = &new base_topiclist;
    $topicList->databaseURI = $this->topicObj->databaseURI;
    $topicList->tableTopics = $this->topicObj->tableTopics;
    $topicList->tableTopicsTrans = $this->topicObj->tableTopicsTrans;
    $topicClass = get_class($this->topicObj);
    $topicList->loadList((int)$this->data['page'], $this->topicObj->topic['TRANSLATION']['lng_id'], 
      TRUE, ((bool)$this->data['sort']), (int)@$this->data['count']);
    $subTopicString = papaya_strings::entityToXML($topicList->getList($topicClass, @(int)$this->data['count']));
    $result .= $subTopicString;
    if (trim($subTopicString) != '') {
      if ($subTopics = $this->createXMLTree($subTopicString)) {
        $parent = NULL;
        $template = &new simple_xmlnode($parent, 'subtopic');
        $templateImage = &new simple_xmlnode($parent, 'image');
        unset($elements);
        unset($thumbs);
        $subTopics->extract($elements, $template);
        if (isset($elements["nodes"]) && is_array($elements["nodes"])) {
          foreach($elements["nodes"] as $node) {
            if (is_object($node)) {
              unset($imageNodes);
              unset($imageNode);
              unset($papayaNode);
              $node->extract($imageNodes, $templateImage);
              if (isset($imageNodes["nodes"]) && is_array($imageNodes["nodes"])) {
                $imageNode = reset($imageNodes["nodes"]);
                $papayaNode = @$imageNode->children[0];
                if (is_object($papayaNode) && @in_array($papayaNode->name, array('papaya:media', 'ndim:media'))) {
                  $thumbs[$node->attributes['no']] = '<papaya:media src="'.$papayaNode->attributes['src'].'" width="'.@(int)$this->data['thumbwidth'].'" height="'.@(int)$this->data['thumbheight'].'" resize="'.@papaya_strings::escapeHTMLChars($this->data['resizemode']).'" />';
                }
              }
            }
          }
        }
        if (isset($thumbs) && is_array($thumbs)) {
          $result .= '<subtopicthumbs>';
          foreach($thumbs as $no=>$thumb) {
            $result .= '<thumb topic="'.(int)$no.'">'.$thumb.'</thumb>';
          }
          $result .= '</subtopicthumbs>';
        }
      }
    }
    include_once(PAPAYA_INCLUDE_PATH.'system/papaya_parser.php');
    $parser = &new papaya_parser;
    $parser->tableTopics = $this->topicObj->tableTopics;
    $result = $parser->parse($result,  $this->topicObj->getContentLanguageId());
    return '<categteaserthumb topic="'.@(int)$this->topicObj->topicId.'">'.$result.'</categteaserthumb>'; 
  }
  
  function getCacheId() {
    return md5(get_class($this).','.@(int)$this->topicObj->topicId);
  }
}
?>