<?php
/**
* Action box page link
*
* @package module_default
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: actbox_pagelink.php,v 1.3 2006/05/24 14:52:14 weinert Exp $
*/

/**
* Basic class Aktion box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');

/**
* Action box page link - generates a link including the current page as referer
*
* @package module_default
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class actionbox_pagelink extends base_actionbox {

  var $preview = FALSE;

  var $editFields = array(
    'caption'=>array ('Caption', 'isNoHTML', TRUE, 'input', 200),
    'css_class'=>array ('CSS class', 'isNoHTML', FALSE, 'input', 20),
    'page_id'=>array ('Page Id', 'isNum', TRUE, 'pageid', 10),
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    if (isset($this->topicObj)) {
      $params['refpage'] = $this->topicObj->topicId;
      if (isset($_SERVER['QUERY_STRING']) && trim($_SERVER['QUERY_STRING']) != '') {
        $params['urlparams'] = $_SERVER['QUERY_STRING'];
      }
      $href = $this->getWebLink(@(int)$this->data['page_id'], NULL, NULL, $params, NULL, @$this->data['caption']);
      if (isset($this->data['css_class']) && trim($this->data['css_class']) != '') {
        return sprintf('<a href="%s" class="%s">%s</a>', $href,
          papaya_strings::escapeHTMLChars($this->data['css_class']),
          papaya_strings::escapeHTMLChars(@$this->data['caption']));
      } else {
        return sprintf('<a href="%s">%s</a>', $href, papaya_strings::escapeHTMLChars(@$this->data['caption']));
      }
    }
    return '';
  }
  
  function getCacheId() {
    return FALSE;
  }
}
?>