<?php
/**
* Actionbox - Login
*
* @package module_community
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: actbox_login.php,v 1.7 2006/05/30 13:20:30 weinert Exp $
*/

/**
* Basic class Action box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');
/**
* Surfer-class
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_surfer.php');

/**
* Actionbox - Login
*
* Community-user registration form
*
* @package module_community
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class actionbox_login extends base_actionbox {

  var $preview = FALSE;

  var $editFields = array(
    'login_id'=>array ('Redirect id (login)', 'isNum', TRUE, 'pageid', 10),
    'logout_id'=>array ('Redirect id (logout)', 'isNum', TRUE, 'pageid', 10)
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    if (!@is_object($GLOBALS['PAPAYA_SURFER'])) {
      $GLOBALS['PAPAYA_SURFER'] = &new base_surfer;
      if(!$GLOBALS['PAPAYA_SURFER']->isValid) {
        $GLOBALS['PAPAYA_SURFER']->loadTopicIdList(TRUE);
      }
    }
    $str = '<box>';
    $str .= $GLOBALS['PAPAYA_SURFER']->getFormXML(!($GLOBALS['PAPAYA_SURFER']->isValid));
    if ( isset($this->data['logout_id']) && ( $this->data['logout_id'] > 0 ) && ( $GLOBALS['PAPAYA_SURFER']->isValid ) ) {
      $href = $this->getWebLink(@(int)$this->data['logout_id'], NULL, NULL, NULL, NULL, NULL);
      $str .= sprintf('<redirect_link href="%s"/>', $href);
    } elseif ( isset($this->data['login_id']) && ( $this->data['login_id'] > 0 ) && !( $GLOBALS['PAPAYA_SURFER']->isValid ) ) {
      $href = $this->getWebLink(@(int)$this->data['login_id'], NULL, NULL, NULL, NULL, NULL);
      $str .= sprintf('<redirect_link href="%s"/>', $href);
    }
    $str .= '</box>';

    return $str;
  }
  
  function getCacheId() {
    return FALSE;
  }
}
?>