<?php
/**
* Page module - user registration
*
* @package module_community
* @author Bodo Grassmann <grassmann@papaya-cms.com>
* @version $Id: content_register.php,v 1.4 2006/05/30 13:21:01 weinert Exp $
*/


/**
* Basic class page module
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_content.php');
/**
* Basic class for check conditions
*/

require_once(PAPAYA_INCLUDE_PATH.'system/sys_checkit.php');
/**
* Page module - user registration
*
* Registration formular for community
*
* @package module_community
* @author Bodo Grassmann <grassmann@papaya-cms.com>
*/
class content_register extends base_content {

  var $tableSurfer = PAPAYA_DB_TBL_SURFER;
  var $tableLink = PAPAYA_DB_TBL_SURFERPERMLINK;

  var $baseSurfers = NULL;

  var $editFields = array(
    'title'=>array ('Title', 'isNoHTML', TRUE, 'input', 200, ''),
    'Success'=>array ('Success', 'isNoHTML', TRUE, 'input', 200, ''),
    'Captions',
    'Caption_Username'=>array ('Username', 'isNoHTML', TRUE, 'input', 50, '', 'Username'),
    'Caption_Givenname'=>array ('Givenname', 'isNoHTML', TRUE, 'input', 50, '', 'Givenname'),
    'Caption_Surname'=>array ('Surname', 'isNoHTML', TRUE, 'input', 50, '', 'Surname'),
    'Caption_Password'=>array ('Password', 'isNoHTML', TRUE, 'input', 50, '', 'Password'),
    'Caption_Confirm_Password'=>array ('Confirm Password', 'isNoHTML', TRUE, 'input', 50, '', 'Confirm Password'),
    'Caption_Email'=>array ('Email', 'isNoHTML', TRUE, 'input', 100, '', 'Email'),
    'Caption_Confirm_Email'=>array ('Confirm Email', 'isNoHTML', TRUE, 'input', 100, '', 'Confirm Email'),
    'Error messages',
    'Error_User_Exists'=>array ('User Exists', 'isNoHTML', TRUE, 'input', 200, ''),
    'Error_Email_Exists'=>array ('Email Exists', 'isNoHTML', TRUE, 'input', 200, ''),
    'Error_Same_Data'=>array ('Same Data', 'isNoHTML', TRUE, 'input', 200, ''),
    'Error_Password_Entry'=>array ('Password Entry', 'isNoHTML', TRUE, 'input', 200, ''),
    'Error_Email_Entry'=>array ('Email Entry', 'isNoHTML', TRUE, 'input', 200, ''),
    'Error_Datafields_Error'=>array ('Datafields Error', 'isNoHTML', TRUE, 'input', 200, ''),
    'Error_Mail_Send'=>array ('Mail Send', 'isNoHTML', TRUE, 'input', 200, ''),
    'Error_Database_Input'=>array ('Database Input', 'isNoHTML', TRUE, 'input', 200, ''),
    'Email',
    'mailfrom_name'=>array ('Mailfrom_name', 'isNoHTML', TRUE, 'input', 200, ''),
    'mailfrom_email'=>array ('Mailfrom_email', 'isEmail', TRUE, 'input', 200, ''),
    'subject'=>array ('Subject', 'isNoHTML', TRUE, 'input', 200, ''),
    'message'=>array ('Message', 'isNoHTML', TRUE, 'textarea', 10, ''),
    'Permissions',
    'default_group'=>array('Default group', 'isNum', TRUE, 'function', 'getSurferGroupCombo')
  );

  /**
  * Content registration
  *
  * @param object base_topic &$topic
  * @access public
  */
  function __construct(&$topic) {
    $this->paramName = 'srg';
    parent::__construct($topic, $this->paramName);
    if(!is_object($this->baseSurfers)) {
      include_once(dirname(__FILE__).'/base_surfers.php');
      $this->baseSurfers = &new surfer_admin($this->msgs);
    }
  }

  function getSurferGroupCombo($name, $field, $data) {
    $this->baseSurfers->loadGroups();
    $result = sprintf('<select name="%s[%s]" class="dialogSelect dialogScale">'.LF,
      $this->paramName, $name);
    if (isset($this->baseSurfers->groupList) && is_array($this->baseSurfers->groupList)) {
      foreach($this->baseSurfers->groupList as $groupId=>$group) {
        $selected = ($groupId == @$data) ? ' selected="selected"' : '';
        $result .= sprintf('<option value="%d"%s>%s</option>', $groupId, $selected,
          htmlspecialchars($group['surfergroup_title']));
      }
    }
    $result .= '</select>'.LF;
    return $result;
  }

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    $result = sprintf('<title>%s</title>'.LF,
    htmlspecialchars(@$this->data['title']));
    $this->initializeParams();
    $this->backLink = '';
    if (isset($this->topicObj->topicId)) {
      $this->baseLink = $this->getBaseLink($this->topicObj->topicId);
    }

    // abfrage zum speichern der daten
    if(isset($this->params['save']) && $this->params['save'] > 0 ) {
    // speichern
      $this->initializeOutputForm();
      $result.=$this->saveOutput();
    }else{
    // ausgeben
    $result.=$this->getOutput();
    }
    return $result;
  }

  /**
  * Get output
  *
  * @access public
  * @return string
  */
  function getOutput(){
    $result ='<registerpage>';
    if (isset($_REQUEST[$this->paramName.'_id'])) {
      $gotoId = $_REQUEST[$this->paramName.'_id'];
      $this->makeValid($gotoId);
      $result.='<success>Erfolgreich verifiziert</success>';
    }else{
      $result.= $this->getOutputForm();
    }
    $result.='</registerpage>';
    return $result;
  }

  /**
  * Make valid
  *
  * @param string $confirmString
  * @access public
  */
  function makeValid($confirmString){
    $surferId = -1;
    $sql = "SELECT surfer_id
          FROM %s
          WHERE surfer_confirmstr = '%s'";
    $params = array($this->tableSurfer, $confirmString);
    if ($res = $this->baseSurfers->databaseQueryFmt($sql, $params)) {
      while($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
        $surferId = $row['surfer_id'];
      }
    }
    if ($surferId != -1) {
      $data = array(
        'surfer_valid' => (int)TRUE,
        'surfer_confirmstr' => ''
      );
      $check = $this->baseSurfers->databaseUpdateRecord($this->tableSurfer, $data, "surfer_id", (int)$surferId);
    } else {
      // fehler der surfer_confirmstr ist nicht vorhanden
    }
  }

  /**
  * Save output
  *
  * @access public
  * @return string
  */
  function saveOutput(){
    $result='<registerpage>';

    if($this->outputDialog->modified()){
      if($this->outputDialog->checkDialogInput()) {
        if(0 == strcmp($this->outputDialog->params['surfer_email_1'],
                        $this->outputDialog->params['surfer_email_2'])
                        ){
          if(0 == strcmp($this->outputDialog->params['surfer_password_1'],
                          $this->outputDialog->params['surfer_password_2'])){
            if($this->checkHandle()){
              if($this->checkEmail()){
                $addUserCheck = $this->addUser();
                if($addUserCheck){
                    $result.='<success>'.$this->data['Success'].'</success>';
                    $GLOBALS['PAPAYA_SURFER']->login($this->outputDialog->params['surfer_handle'],
                                                $this->outputDialog->params['surfer_password_2']);
                }elseif($addUserCheck== -1){
                  $result.='<error>'.$this->data['Error_Mail_Send'].'</error>';
                  $result.=$this->getOutputForm();
                }elseif($addUserCheck== -2){
                  $result.='<error>'.$this->data['Error_Database_Input'].'</error>';
                  $result.=$this->getOutputForm();
                }
              }else{
                $result.='<error>'.$this->data['Error_Email_Exists'].'</error>';
                $result.=$this->getOutputForm();
              }
            }else{
              $result.='<error>'.$this->data['Error_User_Exists'].'</error>';
              $result.=$this->getOutputForm();
            }
          }else{
            $result.='<error>'.$this->data['Error_Password_Entry'].'</error>';
            $result.=$this->getOutputForm();
          }
        }else{
          $result.='<error>'.$this->data['Error_Email_Entry'].'</error>';
          $result.=$this->getOutputForm();
        }
      }else{
        $result.='<error>'.$this->data['Error_Datafields_Error'].'</error>';
        $result.=$this->getOutputForm();
      }
    }
    $result.='</registerpage>';
    return $result;
  }

  /**
  * Add User
  *
  * @access public
  * @return mixed TRUE or integer
  */
  function addUser() {
    srand((double)microtime()*1000000);
    $rand = uniqid(rand());
    $confirmString = substr(crypt($rand, 'PA'), 2, 8);

    $insert = $this->baseSurfers->databaseInsertRecord($this->tableSurfer, 'surfer_id',
      array('surfer_handle'     => $this->outputDialog->params['surfer_handle'],
            'surfer_password'   => md5($this->outputDialog->params['surfer_password_1']),
            'surfer_givenname'  => $this->outputDialog->params['surfer_givenname'],
            'surfer_surname'    => $this->outputDialog->params['surfer_surname'],
            'surfer_email'      => $this->outputDialog->params['surfer_email_1'],
            'surfer_valid'      => FALSE,
            'surfer_confirmstr' => $confirmString,
            'surfergroup_id'    => @(int)$this->data['default_group']
            )
        );
    if($insert){
      if($this->sendMail($confirmString)){
        return $insert;
      }else{
        return -1;
      }
    }else{
      return -2;
    }
  return TRUE;
  }

  /**
  * Send mail
  *
  * @param string $confirmString
  * @access public
  * @return boolean
  */
  function sendMail($confirmString){
    if (preg_match_all('/%([\w]+)%/', $this->data['message'], $regs)) {
      $placeHolder = $regs[0];
    }
    if (isset($placeHolder) && is_array($placeHolder)) {
      foreach($placeHolder as $key=>$val) {
        $tmp[$val] = '';
      }
    }
    $placeHolder = &$tmp;
    $repl = $placeHolder;
    $repl['%NAME%'] = $this->outputDialog->params['surfer_handle'];
    $repl['%EMAIL%'] = $this->outputDialog->params['surfer_email_1'];
    $repl['%TITLE%'] = @$data['title'];
    $repl['%PROJECT%'] = PAPAYA_PROJECT_TITLE;
    $repl['%LINK%'] = 'http://'.$_SERVER['HTTP_HOST'].$this->getBasePath().$this->baseLink.
      '?'.$this->paramName.'_id='.$confirmString;
    $msg = strtr($this->data['message'], $repl);
    $to = $this->outputDialog->params['surfer_handle'].' <'.$this->outputDialog->params['surfer_email_1'].'>';
    $from = 'From:'.$this->data['mailfrom_name'].' <'.$this->data['mailfrom_email'].'>';
    $subject = $this->data['subject'];
    if (!mail($to, $subject, $msg, $from)) {
      $this->logMsg(MSG_WARNING, 6,
        $this->_gtf('Can not send mail to %s.', array($to)),
        $this->_gtf('Can not send mail to %s.', array($to)));
      return FALSE;
    }
  return TRUE;
  }



  /**
  * Check handle exists
  *
  * @access public
  * @return boolean
  */
  function checkHandle(){
                                  // TRUE wenn handle existiert
    return !$this->baseSurfers->existHandle($this->outputDialog->params['surfer_handle']);
  }

  /**
  * Check email
  *
  * @access public
  * @return boolean
  */
  function checkEmail(){
                                // TRUE wenn e-mail existiert
    return !$this->baseSurfers->existEmail($this->outputDialog->params['surfer_email_1']);
  }

  /**
  * Get output formular
  *
  * @access public
  * @return string
  */
  function getOutputForm() {
    $this->initializeOutputForm();
    $this->outputDialog->baseLink = $this->baseLink;
    $this->outputDialog->dialogTitle = htmlspecialchars(@$caption);
    $this->outputDialog->dialogDoubleButtons = FALSE;
    return '<newdlg>'.$this->outputDialog->getDialogXML().'</newdlg>';
  }

  /**
  * Initiaize output formular
  *
  * @access public
  */
  function initializeOutputForm() {
    if (!(isset($this->outputDialog) && is_object($this->outputDialog))) {
      include_once(PAPAYA_INCLUDE_PATH.'system/base_dialog.php');
      $hidden = array( 'save'=>1 );
      $fields = array(
        'surfer_handle' => array(@$this->data['Caption_Username'], 'isNoHTML', TRUE, 'input', 50),
        'surfer_password_1' => array(@$this->data['Caption_Password'], 'isPassword', TRUE, 'password', 50),
        'surfer_password_2' => array(@$this->data['Caption_Confirm_Password'], 'isPassword', TRUE, 'password', 50),
        'surfer_givenname' => array(@$this->data['Caption_Givenname'], 'isNoHTML', TRUE, 'input', 50),
        'surfer_surname' => array(@$this->data['Caption_Surname'], 'isNoHTML', TRUE, 'input', 50),
        'surfer_email_1' => array(@$this->data['Caption_Email'], 'isEmail', TRUE, 'input', 100),
        'surfer_email_2' => array(@$this->data['Caption_Confirm_Email'], 'isEmail', TRUE, 'input', 100)
      );
      $this->outputDialog = &new base_dialog($this, $this->paramName, $fields, $data, $hidden);
      $this->outputDialog->msgs = &$this->msgs;
      $this->outputDialog->loadParams();
    }
  }


}

?>