<?php
/**
* Catalog page navigation
*
* @package module_catalog
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: actbox_catalog_navigation.php,v 1.8 2006/06/01 10:26:14 kelm Exp $
*/

/**
* Basic class aktion box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');

/**
* Function class forum
*/
include_once(dirname(__FILE__).'/base_catalog.php');
/**
* Catalog page navigation - outputs a list of catalog catagories and links to a catalog content page
*
* @package module_catalog
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class actionbox_catalog_navigation extends base_actionbox {

  /**
  * Preview ?
  * @var boolean
  */
  var $preview = TRUE;
  
  /**
  * Content edit fields
  * @var array
  */
  var $editFields = array(
    'page_id' => array ('Page Id', 'isNum', TRUE, 'input', 5, ''),
    'categ_base_id' => array ('Catalog Id', 'isNum', TRUE, 'input', 5, ''),
  );

  /**
  * Get output cache identifier
  *
  * @see base_actionbox::getCacheId()
  *
  * @access public
  * @return mixed Cache Id or FALSE
  */
  function getCacheId() {
    return parent::getCacheId(); //md5(get_class($this).','.@(int)$this->topicObj->topicId);
  }

  /**
  * Return page XML
  *
  * @access public
  * @return string $str
  */
  function getParsedData() {
    $pageId = @(int)$this->data['page_id'];
    if (isset($GLOBALS['PAPAYA_PAGE']) 
      && isset($GLOBALS['PAPAYA_PAGE']->requestData['categ_id'])) {
        $currentCategId = (int)$GLOBALS['PAPAYA_PAGE']->requestData['categ_id'];
    } else {
      $currentCategId = 0;
    }
    $catalog = new base_catalog();
    $catalog->tableTopics = $this->topicObj->tableTopics;
    $catalog->tableTopicsTrans = $this->topicObj->tableTopicsTrans;
    $catalog->loadCatalogList(@(int)$this->data['categ_base_id'], 
      $this->topicObj->getContentLanguageId());
    if (isset($catalog->catalogList) && is_array($catalog->catalogList) && 
        count($catalog->catalogList) > 0) {
      $str = sprintf('<sitemap format="static" date="%s">'.LF, date('Y-m-d H:i:s'));
      foreach ($catalog->catalogList as $category) {
        $focus =($category['catalog_id'] == $currentCategId) ? ' focus="focus"' : '';
        $str .= sprintf('<mapitem id="%d" href="%s" title="%s" enctitle="%s" children="0" allchildren="0" visible="1" %s/>'.LF,
          $category['catalog_id'], 
          $this->getWebLink($pageId, NULL, NULL, NULL, NULL, 
            $category['catalog_title'], $category['catalog_id']),
          $category['catalog_title'], urlencode($category['catalog_title']), $focus);
      }
      $str .= '</sitemap>'.LF;
      return $str;
    }  
    return '';
  }
}
?>
