<?php
/**
* Page module FAQ
*
* @author Bodo Grassmann <grassmann@papaya-cms.com>
* @version $Id: content_faq.php,v 1.8 2006/05/15 09:28:46 weinert Exp $
* @package module_faq
*/

/**
* Basic class page module
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_content.php');
/**
* base FAQ module
*/
include_once(dirname(__FILE__).'/base_faq.php');
/**
* Page module FAQ
*
* @author Bodo Grassmann <grassmann@papaya-cms.com>
* @package module_faq
*/
class content_faq extends base_content {

  /**
  * Content edit fields
  * @var array
  */
  var $editFields = array(
    'faq' => array ('Faq', 'isNoHTML', TRUE, 'function', 'getFaqCombo', ''),
    'Texts',
    'nl2br' => array ('Automatic linebreak', 'isNum', FALSE, 'combo', array(0=>'Yes', 1=>'No'),
      'Papaya will apply your linebreaks to the output page.'),
    'title' => array ('Title', 'isNoHTML', TRUE, 'input', 200, ''),
    'teaser' => array ('Teaser', 'isSomeText', FALSE, 'simplerichtext', 10),
    'text' => array ('Text', 'isSomeText', FALSE, 'richtext', 20),
    'page splitting',
    'commentperpage' => array ('Comments per page', 'isNum', TRUE, 'input', 4, '', 30),
    'entryperpage' => array ('Entries per page', 'isNum', TRUE, 'input', 4, '', 10),
    'permissions',
    'post_comments' => array ('Post comments', 'isNum', TRUE, 'function', 'getPermsCombo', '', 30),
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    $result = sprintf('<title>%s</title>'.LF,
      htmlspecialchars(@$this->data['title']));
    $result .= sprintf("<teaser>%s</teaser>".LF, @$this->getXHTMLString($this->data['teaser'],
      !((bool)$this->data['nl2br'])));
    $result .= sprintf("<text>%s</text>".LF, $this->getXHTMLString(@$this->data['text'],
      !((bool)@$this->data['nl2br'])));
    $faq = &new base_faq();
    $faq->module = &$this;
    $faq->baseLink = $this->getBaselink($this->topicObj->topicId);
    $faq->tableTopics = $this->topicObj->tableTopics;
    $faq->tableTopicsTrans = $this->topicObj->tableTopicsTrans;
    $faq->contentLanguageId = $this->topicObj->getContentLanguageId();
    $result .= $faq->getOutput($this->data);
    return $result;
  }

  /**
  * Get parsed Teaser
  *
  * @access public
  * @return string
  */
  function getParsedTeaser() {
    if (@trim($this->data['teaser']) != '') {
      $result = sprintf('<title>%s</title>'.LF, $this->getXHTMLString(@$this->data['title']));
      $result .= sprintf("<text>%s</text>".LF, @$this->getXHTMLString($this->data['teaser'],
        !((bool)$this->data['nl2br'])));
      return $result;
    }
    return '';
  }


  /**
  * Get faq combo
  *
  * @param string $name
  * @param array $field
  * @param array $data
  * @access public
  * @return string
  */
  function getFaqCombo($name, $field, $data) {
    $result = '';
    $this->faqObject = &new base_faq();
    $this->faqObject->loadFaqs();
    $result .= sprintf('<select name="%s[%s]" class="dialogSelect dialogScale">'.LF,
    $this->paramName, $name);
    if (isset($this->faqObject->faqs) && is_array($this->faqObject->faqs)) {
      foreach ($this->faqObject->faqs as $id => $faq) {
        $selected = ($data == $faq['faq_id']) ? ' selected="selected"' : '';
        $result .= sprintf('<option value="%d" %s>%s</option>'.LF,
        $faq['faq_id'],
        $selected,
        htmlspecialchars($faq['faq_title']));
      }
    }
    $result .= '</select>'.LF;
    return $result;
  }
}
?>