<?php
/**
* Page module forum
*
* @package module_forum
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: content_forum.php,v 1.5 2006/01/23 17:22:54 weinert Exp $
*/

/**
* Basic class Page module
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_content.php');
/**
* Base forum class
*/
include_once(dirname(__FILE__).'/base_forum.php');

/**
* Page module Forum
*
* Seperate individual forum or complete categoy
*
* @package module_forum
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class content_forum extends base_content {

  /**
  * Edit fields
  * @var string
  */
  var $editFields = array(
    'title'=>array ('Title', 'isNoHTML', TRUE, 'input', 200, ''),
    'forum'=>array ('Forum', 'isNoHTML', TRUE, 'function', 'getForumCombo', ''),
    'mode'=>array ('Mode', 'isNum', TRUE, 'combo', array(0=>'Threaded', 1=>'BBS', 2=>'Threaded BBS'), '', 0),
    'text',
    'nl2br'=>array ('Automatic linebreak', 'isNum', FALSE, 'combo', array(0=>'Yes', 1=>'No'),
      'Apply linebreaks from input to the HTML output.'),
    'text'=>array ('Text', 'isSomeText', FALSE, 'richtext', 10),
    'page splitting',
    'perpage'=>array ('Threads per page', 'isNum', TRUE, 'input', 4, '', 30),
    'bbsperpage'=>array ('Entries per page', 'isNum', TRUE, 'input', 4, '', 10),
    'input form',
    'caption_newanswer'=>array ('Title - answer', 'isNoHTML', TRUE, 'input', 50, '', 'Answer'),
    'caption_newquestion'=>array ('Title - question',  'isNoHTML', TRUE, 'input', 50, '', 'Question'),
    'permissions',
    'post_anwers'=>array ('Post Answers', 'isNum', TRUE, 'function', 'getPermsCombo', '', 30),
    'post_questions'=>array ('Post Questions', 'isNum', TRUE, 'function', 'getPermsCombo', '', 30),
    'search',
    'caption_search'=>array('Title', 'isNoHTML', TRUE, 'input', 50, '', 'Search'),
    'msg_noresult'=>array('Message - no result', 'isSomeText', TRUE, 'textarea', 4, '', 'No threads found.'),
    'msg_invalid'=>array('Message - invalid', 'isSomeText', TRUE, 'textarea', 4, '', 'Invalid search string.'),
    'Emails',
    'admin_sendmails'=>array('Send moderator emails', 'isNum', TRUE, 'combo', array(1=>'Yes', 0=>'No'), '', 1),
    'admin_name'=>array('Moderator name', 'isNoHTML', TRUE, 'input', 50, '', 'Forum moderator'),
    'admin_email'=>array('Moderator email', 'isEMail', TRUE, 'input', 50, '', 'webmaster@domain.tld'),
    'sendmails'=>array('Send notify emails', 'isNum', TRUE, 'combo', array(1=>'Yes', 0=>'No'), '', 0),
    'mailfrom_name'=>array('From name', 'isNoHTML', TRUE, 'input', 50, '', 'Forum'),
    'mailfrom_email'=>array('From email', 'isEMail', TRUE, 'input', 100, '', 'admin@localhost'),
    'mailsubject'=>array('Email subject', 'isNoHTML', TRUE, 'input', 200, '', 'New entry in forum'),
    'mailtext'=>array('Email text', 'isSomeText', TRUE, 'textarea', 10, ''),
    'notifyquestion'=>array('Notify question', 'isSomeText', TRUE, 'textarea', 10, '',
      'Do you want to deactivate the notify mails for this thread?')
  );

  /**
  * Set data
  *
  * @param string $xmlData
  * @access public
  */
  function setData($xmlData) {
    parent::setData($xmlData);
    if (isset($this->data['mailtext']) && trim($this->data['mailtext']) == '') {
      $this->data['mailtext'] = $this->_gtfile('forum_newentry.txt');
    }
  }

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    $result = sprintf('<title>%s</title>'.LF,
      $this->getXHTMLString(@$this->data['title']));
    $result .= sprintf("<text>%s</text>",
      $this->getXHTMLString(@$this->data['text'], !((bool)@$this->data['nl2br'])));

    $forumObject = &new base_forum();
    $forumObject->module = &$this;
    $params['mode'] = (int)@$this->data['mode'];
    $params['perpage'] = (int)@$this->data['perpage'];
    $params['bbsperpage'] = (int)@$this->data['bbsperpage'];

    $params['msg_noresult'] = @$this->data['msg_noresult'];
    $params['msg_invalid'] = @$this->data['msg_invalid'];
    $params['caption_newanswer'] = @$this->data['caption_newanswer'];
    $params['caption_newquestion'] = @$this->data['caption_newquestion'];
    $params['caption_search'] = @$this->data['caption_search'];

    $params['admin_sendmails'] = (int)@$this->data['admin_sendmails'];
    $params['admin_email'] = @$this->data['admin_email'];
    $params['admin_name'] = @$this->data['admin_name'];
    $params['sendmails'] = (int)@$this->data['sendmails'];

    $params['mailsubject'] = @$this->data['mailsubject'];
    $params['mailfrom_name'] = @$this->data['mailfrom_name'];
    $params['mailfrom_email'] = @$this->data['mailfrom_email'];
    $params['mailtext'] = (isset($this->data['mailtext']) && trim($this->data['mailtext']) != '') ? $this->data['mailtext'] : $this->_gtfile('forum_newentry.txt');
    $params['notifyquestion'] = @$this->data['notifyquestion'];
    $params['post_questions'] = $this->checkSurferPerm((int)@$this->data['post_questions']);
    $params['post_anwers'] = $this->checkSurferPerm((int)@$this->data['post_anwers']);
    $result .= $forumObject->getOutput($this->decodeDataForum(@$this->data['forum']), $params);
    return $result;
  }

  /**
  * Decode data forum
  *
  * @param string $str
  * @access public
  * @return array
  */
  function decodeDataForum($str) {
    $currentData = explode(';', $str);
    $result = array(
      'mode' => (@trim($currentData[0]) == 'forum') ? 'forum' : 'categ',
      'id' => @trim($currentData[1])
    );
    return $result;
  }
  
  /**
  * Get forum combo
  *
  * @param string $name
  * @param array $field
  * @param string $data
  * @access public
  * @return string
  */
  function getForumCombo($name, $field, $data) {
    include_once(dirname(__FILE__).'/admin_forum.php');
    $this->forumObject = &new admin_forum();
    return $this->forumObject->getForumCombo($this->paramName, $name, $this->decodeDataForum($data));
  }
}
?>