<?php
/**
* Action box for flash
*
* @package module_embed
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: actbox_flash.php,v 1.2 2006/05/22 11:02:06 kelm Exp $
*/

/**
* Basic class aktion box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');
/**
* Action box for HTML
*
* @package module_embed
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class actionbox_flash extends base_actionbox {

  /**
  * Preview ?
  * @var boolean
  */
  var $preview = TRUE;

  /**
  * Content edit fields
  * @var array
  */
  var $editFields = array(
    'flashfile'=>array ('Flash filename', 'isSomeText', TRUE, 'input', 100),
    'width'=>array ('Width', 'isNumUnit', FALSE, 'input', 5),
    'height'=>array ('Height', 'isNumUnit', FALSE, 'input', 5),
    'version'=>array ('Flash version', 'isNum', FALSE, 'input', 5, '', 5),
    'Movie options',
    'scale'=>array ('Scaling mode', 'isAlpha', TRUE, 'combo', array('showall'=>'Standard', 'exactfit'=>'Exact fit', 'noborder'=>'No border', 'noscale'=>'noscale')),
    'shalign'=>array ('Horizontal Align', 'isAlpha', FALSE, 'combo', array('m'=> 'Middle', 'l'=>'Left', 'r'=>'Right')),
    'svalign'=>array ('Vertical Align', 'isAlpha', FALSE, 'combo', array('m'=> 'Middle', 't'=>'Top', 'b'=>'Bottom')),
    'quality'=>array ('Quality', 'isAlpha', FALSE, 'combo', array('high'=>'High', 'medium'=> 'Medium', 'low'=>'Low')),
    'Alternative texts',
    'noscript'=>array ('No script', 'isSomeText', FALSE, 'textarea', 10, '', 'Please activate JavaScript!'),
    'noflash'=>array ('No Flash', 'isSomeText', FALSE, 'textarea', 10, '')
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    $fileName = '';
    if (preg_match('#^[a-z\d]{32}\.swf$#', $this->data['flashfile']) &&
        file_exists(PAPAYA_PATH_MEDIAFILES.$this->data['flashfile'])) {
      $fileName = $this->getWebMediaLink($this->data['flashfile'], 'media');
    } elseif (file_exists(getenv('DOCUMENT_ROOT').'/'.$this->data['flashfile'])) {
      $fileName = $this->data['flashfile'];
    } elseif (checkit::isHTTPX($this->data['flashfile'], TRUE) &&
              (strtolower(substr($this->data['flashfile'],-4)) == '.swf')) {
      $fileName = $this->data['flashfile'];
    }
    if ($fileName != '') {
      $noFlash = (trim($this->data['noflash']) != '') ? "'".$this->escapeForJs($this->data['noflash'])."'" : 'null';
      $noScript = (trim($this->data['noscript']) != '') ? $this->getXHTMLString($this->data['noscript']) : '';
      $result = '<script type="text/javascript">';
      $result .= '<!--'.LF;
      $result .= sprintf("outputFlash(hasFlash(%d), '%s', '%s', '%s', %s, '%s', '%s%s', '%s');".LF,
        $this->data['version'], htmlspecialchars($fileName),
        htmlspecialchars($this->data['width']), htmlspecialchars($this->data['height']),
        $noFlash, htmlspecialchars($this->data['scale']),
        strtoupper(htmlspecialchars(str_replace('m','',$this->data['svalign']))),
        strtoupper(htmlspecialchars(str_replace('m','',$this->data['shalign']))),
        htmlspecialchars($this->data['quality']));
      $result .= '//-->'.LF;
      $result .= '</script>'.LF;
      $result .= '<noscript>'.$noScript.'</noscript>';
      return $result;
    } else {
      return '';
    }
  }

  /**
  * Escaping for js
  *
  * @param string $str
  * @access public
  * @return string
  */
  function escapeForJs($str) {
    $result = addslashes($str);
    return str_replace('</',"<'+'/",$result);
  }
}
?>