<?php
/**
* Mailto Box
*
* @package module_mail
* @author David Rekowski <rekowski@papaya-cms.com>
* @version $Id: actbox_sendpage_mailto.php,v 1.4 2005/11/02 15:25:24 grassmann Exp $
*/

/**
* Mailto Box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');
/**
* Mailto Box
*
* @package module_mail
* @author David Rekowski <rekowski@papaya-cms.com>
*/
class actionbox_sendpage_mailto extends base_actionbox {

  var $editFields = array(
    'title' => array('Link Title', 'isNoHTML', false, 'input', 200, '', 'send page'),
    'subject' => array('Subject template of email', 'isNoHTML', false, 'input', 200, '', 'someone sent you this webpage'),
    'body' => array('Body template of email', 'isNoHTML', false, 'textarea', 20, '', "{%title%}\n\n{%teaser%}\n\n{%link%}"),
  );

  function getParsedData() {
    $result = '<mailto>'.LF;
    $result .= sprintf('<title encoded="%s">%s</title>'.LF,
      rawurlencode(@$this->data['title']), $this->getXHTMLString(@$this->data['title']));
    $result .= sprintf('<mailtolink>%s</mailtolink>'.LF, $this->getXHTMLString($this->getMailtoLink()));
    $result .= '</mailto>'.LF;
    return $result;
  }

  /**
  * get mailto link
  *
  * linkes topic object from id and fetches data by using simple_xmltree
  * @uses simple_xmltree:create()
  * @uses email:getMailtoLink()
  * @return string mailto link e.g. mailto:?subject=something%20as%20title&body=something%20else
  */
  function getMailtoLink() {
    include_once(PAPAYA_INCLUDE_PATH.'system/sys_email.php');

    $topicId = $this->topicObj->topicId;
    if (isset($GLOBALS['PAPAYA_PAGE'])) {
      $className = get_class($this->topicObj);
      $this->linkedTopic = &new $className();
      if ($this->linkedTopic->topicExists($topicId) &&
          $this->linkedTopic->loadOutput($topicId, $this->topicObj->getContentLanguageId())) {
        if ($GLOBALS['PAPAYA_PAGE']->validateAccess($topicId)) {
          $xmlTree = simple_xmltree::create();
          if ($str = $this->linkedTopic->parseContent(FALSE)) {
            $xmlTree->loadFromString($str);
            if (is_object($xmlTree->root)) {
              foreach($xmlTree->root->children as $node) {
                if (is_object($node)) {
                  switch ($node->name) {
                    case 'text' :
                    case 'title' :
                      $s = '';
                      $node->printText($s);
                      $content[$node->name] = $s;
                    break;
                  }
                }
              }
              $this->emailObj = new email();

              $templateValues['title']  = @$content['title'];
              $templateValues['teaser'] = @$content['text'];
              $templateValues['link']   = $this->getAbsoluteURL($this->getWebLink());

              $this->emailObj->setTemplate('subject', @$this->data['subject'], $templateValues);
              $this->emailObj->setTemplate('body', @$this->data['body'], $templateValues);
              return $this->emailObj->getMailtoLink();
            }
          }
        }
      }
    }
    return '';
  }
}
?>