<?php
/**
* Page module - Send feedback email and store values in DB
*
* @package module_feedback
* @author David Rekowski <rekowski@papaya-cms.com>
* @version $Id:$
*/

/**
* Basic database object class
*/
require_once(PAPAYA_INCLUDE_PATH.'system/sys_base_db.php');

/**
* basic feedback content class
*/
require_once(dirname(__FILE__).'/content_feedback.php');

/**
* Page module - Send feedback email and store values in DB
*
* @package module_feedback
* @author David Rekowski <rekowski@papaya-cms.com>
*/
class content_feedback_store extends content_feedback {

  var $dbObj = NULL;

  function sendEmail() {
    $result = '';
    $content['NAME']    = $this->params['mail_name'];
    $content['FROM']    = $this->params['mail_from'];
    $content['SUBJECT'] = $this->params['mail_subject'];
    $content['TEXT']    = $this->params['mail_message'];

    if (isset($this->params['mail_from'])) {
      $this->emailObj->setHeader('From', @$this->params['mail_from']);
    }
    $this->emailObj->setTemplate('subject', @$this->data['msg_subject'], $content);
    $this->emailObj->setTemplate('body', @$this->data['msg_body'], $content);

    if ($this->emailObj->send(@$this->data['msg_mailto'])) {
      $this->storeFeedback();
      $result .= sprintf('<message type="normal">%s</message>'.LF, @$this->getXHTMLString($this->data['msg_send']));
      if (!empty($this->data['confirm_subject'])) {
        $emailConfirmObj = new email();
        $emailConfirmObj->setHeader('From', $this->data['msg_mailto']);
        $emailConfirmObj->send(@$this->params['mail_from'], @(string)$this->data['confirm_subject'], @(string)$this->data['confirm_body']);
      }
    } else {
      $result .= sprintf('<message type="warning">%s</message>'.LF, @$this->getXHTMLString($this->data['msg_notsend']));
    }
    return $result;
  }

  function storeFeedback() {
    if (!isset($this->dbObj) || !is_object($this->dbObj) || get_class($this->dbObj != 'base_db')) {
      $this->dbObj = &new base_db;
    }
    $this->tableFeedback = PAPAYA_DB_TABLEPREFIX.'_feedback';
    $data = array(
      'feedback_time'    => time(),
      'feedback_email'   => $this->params['mail_from'],
      'feedback_name'    => $this->params['mail_name'],
      'feedback_subject' => $this->params['mail_subject'],
      'feedback_message' => $this->params['mail_message'],
    );
    if ($this->dbObj->databaseInsertRecord($this->tableFeedback, NULL, $data)) {
      return TRUE;
    }
    return FALSE;
  }

}

?>