<?php
/**
* Action box shows a random thumbnail from the media db
*
* @package module_default
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: actbox_thumbnail.php,v 1.4 2006/04/21 15:49:52 weinert Exp $
*/

/**
* Basic class aktion box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');
/**
* file manager
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_fileman.php');

/**
* Action box shows a random thumbnail from the media db
*
* @package module_default
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class actionbox_thumbnail extends base_actionbox {

  /**
  * Preview possible
  * @var boolean
  */
  var $preview = TRUE;

  /**
  * Content edit fields
  * @var array
  */
  var $editFields = array(
    'directory'=>array ('Folder', 'isNum', TRUE, 'function', 'mediadirectory', '', 0),
    'thumbwidth'=>array ('Thumbnail width', 'isNum', TRUE, 'input', 5, '', 100),
    'thumbheight'=>array ('Thumbnail height', 'isNum', TRUE, 'input', 5, '', 100),
    'url'=>array ('Link target', 'isNoHTML', FALSE, 'input', 100, '')
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    $result = '';
    $fileManager = &new base_filemanager;
    $fileManager->initialize();

    $fileManager->dataDirectory = PAPAYA_PATH_MEDIAFILES;
    $fileManager->thumbnailDirectory = PAPAYA_PATH_THUMBFILES;
    $fileManager->folderId = (int)$this->data['directory'];

    if ($file = $fileManager->dataRandomImage()) {
      $href = $this->getAbsoluteURL(@$this->data['url'], '', TRUE);
      $hrefStr = ($href != '') ? ' href="'.$href.'"' : '';
      $result = sprintf('<papaya:media href="%s" src="%s" width="%d" height="%d" align="center" lspace="0" tspace="0" rspace="0" bspace="0" subtitle="%s" title="%s" %s/>'.LF,
        $href, $file['file_id'], (int)$this->data['thumbwidth'], (int)$this->data['thumbheight'], htmlspecialchars($file['file_title']), htmlspecialchars($file['file_title']), $hrefStr);
    }
    return $result;
  }

  /**
  * Media directory
  *
  * @param string $name
  * @param array $field
  * @param integer $data
  * @access public
  * @return string
  */
  function mediadirectory($name, $field, $data) {
    $result = '';
    include_once(PAPAYA_INCLUDE_PATH.'system/base_language_select.php');
    $this->lngSelect = &base_language_select::getInstance();

    include_once(PAPAYA_INCLUDE_PATH.'system/papaya_fileman.php');
    $fileManager = &new papaya_filemanager;
    $fileManager->initialize();

    $fileManager->dataDirectory = PAPAYA_PATH_MEDIAFILES;
    $fileManager->thumbnailDirectory = PAPAYA_PATH_THUMBFILES;

    $fileManager->dataLoadFolderList($this->lngSelect->currentLanguageId);
    $this->folders = $fileManager->folders;
    if ( isset($fileManager->folderLinks))
      $this->folderLinks = $fileManager->folderLinks;

    $result .= sprintf('<select name="%s[%s]" class="dialogSelect dialogScale">'.LF,
      $this->paramName, $name);
    $result .= $this->getFolder(0,(int)$data, 0);
    $result .= '</select>'.LF;

    return $result;
  }

  /**
  * Get folder
  *
  * @param integer $id
  * @param integer $selId
  * @param integer $indent optional, default value 0
  * @access public
  * @return string
  */
  function getFolder($id, $selId, $indent=0) {
    $result = '';
    $folder = $this->folders[$id];
    $subFolders = @$this->folderLinks[$id]['CHILDS'];
    if (isset($folder) && is_array($folder)) {
      if ($selId == $id) {
        $selected = ' selected="selected"';
      } else {
        $selected = '';
      }
      $result .= sprintf('<option value="%d"%s>%s%s</option>'.LF,
        $folder['folder_id'], $selected, str_repeat('-',$indent*2), htmlspecialchars($folder['folder_title']));
      if (isset($subFolders) && is_array($subFolders)) {
        foreach($subFolders as $sub) {
          $result .= $this->getFolder($sub, $selId, $indent+1);
        }
      }
    }
    return $result;
  }
}
?>