<?php
/**
* Define some status tables
* @package papaya
* @version $Id: base_statictables.php,v 1.8 2006/05/08 08:57:13 weinert Exp $
*/

/**
* Define some status tables
* @author Thomas Weinert
* @package papaya
*/
class base_statictables {

  /**
  * States for a page
  * @return array
  */
  function getTableStates() {
    return array(
      1=>'Created',
      2=>'Ready',
      3=>'Edited',
      4=>'Working'
    );
  }

  /**
  * States for a page access permissions
  * @return array
  */
  function getTableAccessStates() {
    return array(
      1=>'Own permissions',
      2=>'Inherited permissions',
      3=>'Additional permissions'
    );
  }

  /**
  * Option groups
  * @return array
  */
  function getTableOptGroups() {
    return array(
      0=>'Unknown',
      1=>'Tables',
      2=>'Files and Directories',
      3=>'Debugging',
      4=>'Language',
      5=>'Project defaults',
      6=>'Internals',
      7=>'System',
      8=>'Layout',
      9=>'Default pages',
      10=>'Charsets',
      11=>'Overview page',
      12=>'Login'
    );
  }

  /**
  * Log message groups
  * @return array
  */
  function getTableLogGroups() {
    return array(
      1=>'User',
      2=>'Pages',
      3=>'Database',
      4=>'Calender',
      5=>'Cronjobs',
      6=>'Community',
      7=>'System',
      8=>'Modules',
      9=>'PHP'
    );
  }

  /**
  * Authentication permission groups
  * @return array
  */
  function getAuthPermGroups() {
    return array(
      1 => 'Misc',
      2 => 'Pages',
      3 => 'Administration',
      4 => 'Media database',
      5 => 'Boxes',
      6 => 'Internals',
      7 => 'Modules'
    );
  }

  function getChangeLevels() {
    return array(
      1 => 'Minor',
      2 => 'Major',
      3 => 'Normal',
      4 => 'New',
    );
  }

  function getTodoPriorities() {
    return array(
      0 => 'normal',
      1 => 'high',
      2 => 'urgent',
     );
  }

  function getTodoStates() {
    return array(
      0 => 'normal',
      1 => 'urgent',
      2 => 'overdue',
    );
  }

}
?>