<?php
/**
*
* Administration implementation of programm id files for Papaya-Cron-Moduls
*
* @package papaya_base
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: sys_pidfile.php,v 1.1.1.1 2005/09/30 15:51:09 weinert Exp $
*/


/**
*
* Administration implementation of programm id files for Papaya-Cron-Moduls
*
* @package papaya_base
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class pidfile {
    var $pidfile = '/tmp/actual.pid';
    var $pid = 0;
    var $oldPid = 0;



    /**
    * Copy parameter $pidfile in $this->pidfile when parameter is set
    */
    function __construct($pidfile = NULL) {
      if (isset($pidfile)) $this->pidfile = $pidfile;
    }

  /**
  * PHP 4 constuctor redirect
  *
  * @access public
  */
  function pidfile() {
    $args = &func_get_args();
    call_user_func_array(array(&$this, '__construct'), $args);
  }


    /**
    * Inizialisation of PID.
    * @return mixed True if pid wasn't set and set through function or
    * FALSE when pid was set
    */
    function execute() {
      if (!$this->get()) {
        return $this->set();
      } else {
        return FALSE;
      }
    }

    /**
    * Read PID
    * @return boolean
    */
    function get() {
      $this->oldPid = 0;
      if (file_exists($this->pidfile)) {
        if ($fh = fopen($this->pidfile, 'r')) {
          $this->oldPid = (int)chop(fgets($fh,20));
          fclose($fh);
        }
      } else {
      }
      $this->pid = posix_getpid();
      if (($this->oldPid > 0) && ($this->oldPid != $this->pid)) {
        echo $this->oldPid,'#', $this->pid;
        if (posix_kill($this->oldPid, '0')) {
          return TRUE;
        } else {
          return FALSE;
        }
      } else {
        return FALSE;
      }
    }

    /**
    * Create a new PID - file
    * @return boolean True if pid wrote and FALSE when an error appears during worte command
    */
    function set() {
      if ($fh = fopen($this->pidfile, 'w')) {
        fwrite($fh,$this->pid);
        fclose($fh);
        chmod($this->pidfile, 0766);
        return TRUE;
      }
      return FALSE;
    }

    /**
    * Delete PID-File
    */
    function delete() {
      if (file_exists($this->pidfile)) {
        unlink($this->pidfile);
      }
    }
}
?>