<?php
/**
* Embedrichtext controls - javascript
* @module papaya-admin
* @author Thomas Weinert <weinert@papaya-cms.de>
* @version $Id: js.richtext.php,v 1.4 2006/01/12 15:59:53 weinert Exp $
*/

/**
* Do not show database errors
*/
define('PAPAYA_DBG_DATABASE_ERROR', '0');

/**
* Authentication
*/
require_once("./inc.auth.php");

if ($PAPAYA_SHOW_ADMIN_PAGE) {
  header('Content-type: text/javascript');
?>
var scriptBasePath = '<?php echo $PAPAYA_OPTIONS->getAbsoluteUrl(PAPAYA_PATHWEB_ADMIN); ?>script/';
var oPapayaParser = new papayaParser();
oPapayaParser.base_url = '<?php echo $PAPAYA_OPTIONS->getAbsoluteUrl(PAPAYA_PATHWEB_ADMIN); ?>';

function initializeRichtext() {
  var tas = document.getElementsByTagName("textarea");
  for (var i = tas.length-1; i >= 0; i--) {
    var toolbar = null;
    if (tas[i].className.search(/(^|\s)dialogRichtext(\s|$)/) >= 0)  {
      toolbar = 'complete';
    } else if (tas[i].className.search(/(^|\s)dialogSimpleRichtext(\s|$)/) >= 0) {
      toolbar = 'simple';
    }
    if (toolbar != null) {
      var editorId = tas[i].id;
      tas[i].oPapayaParser = oPapayaParser;
      var tasHeight = tas[i].style.height;
      if (tasHeight == '') {
        tasHeight = (String((parseInt(tas[i].rows) + 5) * 15)) + 'px';
      }
      var editor = new FCKeditor(editorId, tas[i].style.width, tasHeight, toolbar);
      editor.BasePath  = scriptBasePath+'fck/';
      editor.Config['CustomConfigurationsPath'] = '<?php echo $PAPAYA_OPTIONS->getAbsoluteUrl('js.richtext_config.php'); ?>';
      editor.Config['SkinPath'] = scriptBasePath+'fck/editor/skins/<?php echo $PAPAYA_USER->options['PAPAYA_UI_THEME']; ?>/';
      editor.Config['FormatSource'] = true;
      editor.Config['FormatOutput'] = true;

      if (!editor.CheckBrowser || editor._IsCompatibleBrowser()) {
        var RegEx = tas[i].name.match(/^(.*)\[[\w\d]+\]$/);
        var sFieldName = (RegEx) ? RegEx[1]+'[nl2br]' : 'nl2br';
        var nl2br = getLineBreakFieldStatus(tas[i].form, sFieldName);
        if (nl2br) {
          tas[i].value = tas[i].value.replace(/\r\n|\n\r|[\r\n]/, '<br />');
        }
        editor.ReplaceTextarea();
      } else {
        tas[i].value = oPapayaParser.stripDynamicAttributes(tas[i].value);
      }
    }
  }
}

var nl2brData = new Array();

function getLineBreakFieldStatus(oForm, sFieldName) {
  for (var k = 0; k < nl2brData.length; k++) {
    if (oForm = nl2brData[k].form) {
      return nl2brData[k].nl2br;
    }
  }

  var oField = oForm.elements[sFieldName];
  if (oField) {
    var nl2br = (oField.value != '1') ? true : false;

    //Save data for next textarea
    var aData = new Array();
    aData.form = oForm;
    aData.nl2br = nl2br;
    nl2brData[nl2brData.length] = aData;

    //Change field value
    oField.value = '1';
    oField.style.display = 'none';
    
    visibleField = document.createElement('input');
    visibleField.value = 'No';
    visibleField.className = oField.className;
    visibleField.disabled = true;
    oField.parentNode.appendChild(visibleField);

    return nl2br;
  } else {
    return false;
  }

}
<?php
  }
?>
