function papayaPopupInput(field, dialogType) {
  this.editField = field;
  this.dialogType = dialogType;
  
  var cssWidth = '';
  if (window.getComputedStyle) {
    cssWidth = parseInt(window.getComputedStyle(this.editField, null).width);
  } else if (this.editField.currentStyle) {
    cssWidth = parseInt(this.editField.currentStyle.width);  
  }
  var cellNode = this.editField.parentNode;
  
  popupInput = document.createElement('table');
  popupInput.cellSpacing = 0;
  popupInput.cellPadding = 0;
  popupInput.style.width = cssWidth+'px';
  
       
  var tb = document.createElement('tbody');
  popupInput.appendChild(tb);
  var tr = document.createElement('tr');
  tb.appendChild(tr);
  var td = document.createElement('td');
  tr.appendChild(td);
  
  this.editField.style.width = (cssWidth - 65)+'px';
  td.appendChild(this.editField);
  
  button = document.createElement('input');
  button.type = 'button';
  button.className = 'dialogPopupButton';
  button.value = '...';
  button.linkedPopup = this;
  button.onclick = papayaOpenPopupHandler;
  
  var td = document.createElement('td');
  tr.appendChild(td);
  td.appendChild(button);
  
  cellNode.appendChild(popupInput); 
}

papayaPopupInput.prototype.execute = function() {
  switch (this.dialogType) {
    case 'imageFixed' : 
      this.openPopupBrowseImage();
      break;
    case 'image' : 
      this.openPopupImage();
      break;
    case 'pageId' : 
      this.openPopupBrowsePages();
      break;
    case 'date' : 
      this.openPopupDate();
      break;
    case 'color' : 
      this.openPopupColor();
      break;
    case 'mediaFile' :
      this.openPopupBrowseMediafile();
      break;
    default : 
      alert('Not Implemented'); 
      break;
  }
}

papayaPopupInput.prototype.openPopupBrowseImage = function() {
	// Set the browser window feature.
	var iWidth	= Math.round(screen.width * 0.7);
	var iHeight	= Math.round(screen.height * 0.7);

	var iLeft = Math.round((screen.width  - iWidth) / 2);
	var iTop  = Math.round((screen.height - iHeight) / 2);

	var sOptions = "toolbar=no, status=no, resizable=no, dependent=yes" ;
	sOptions += ", width=" + iWidth ;
	sOptions += ", height=" + iHeight ;
	sOptions += ", left=" + iLeft ;
	sOptions += ", top=" + iTop ;

	var oWindow = window.open('script/controls/browseimg.html', 'PapayaPopupWindow', sOptions);
  oWindow.linkedObject = this;  
}

// X-perimentell
papayaPopupInput.prototype.openPopupBrowseMediafile = function() {
	// Set the browser window feature.
	var iWidth	= Math.round(screen.width * 0.7);
	var iHeight	= Math.round(screen.height * 0.7);

	var iLeft = Math.round((screen.width  - iWidth) / 2);
	var iTop  = Math.round((screen.height - iHeight) / 2);

	var sOptions = "toolbar=no, status=no, resizable=no, dependent=yes" ;
	sOptions += ", width=" + iWidth ;
	sOptions += ", height=" + iHeight ;
	sOptions += ", left=" + iLeft ;
	sOptions += ", top=" + iTop ;

	var oWindow = window.open('script/controls/browsemediafile.html', 'PapayaPopupWindow', sOptions);
  oWindow.linkedObject = this;  
}

papayaPopupInput.prototype.openPopupImage = function() {
	// Set the browser window feature.
	var iWidth	= 304;
	var iHeight	= 400;

	var iLeft = Math.round((screen.width  - iWidth) / 2);
	var iTop  = Math.round((screen.height - iHeight) / 2);

	var sOptions = "toolbar=no, status=no, resizable=yes, dependent=yes" ;
	sOptions += ", width=" + iWidth ;
	sOptions += ", height=" + iHeight ;
	sOptions += ", left=" + iLeft ;
	sOptions += ", top=" + iTop ;

	var oWindow = window.open('script/controls/image.html', 'PapayaPopupWindow', sOptions);
  oWindow.linkedObject = this; 
}

papayaPopupInput.prototype.openPopupBrowsePages = function() {
	// Set the browser window feature.
	var iWidth	= 300;
	var iHeight	= 300;

	var iLeft = Math.round((screen.width  - iWidth) / 2);
	var iTop  = Math.round((screen.height - iHeight) / 2);

	var sOptions = "toolbar=no, status=no, resizable=no, dependent=yes" ;
	sOptions += ", width=" + iWidth ;
	sOptions += ", height=" + iHeight ;
	sOptions += ", left=" + iLeft ;
	sOptions += ", top=" + iTop ;

	var oWindow = window.open('script/controls/link.html', 'PapayaPopupWindow', sOptions);
  oWindow.linkedObject = this;  
}

papayaPopupInput.prototype.openPopupDate = function() {
	// Set the browser window feature.
	var iWidth	= 300;
	var iHeight	= 300;

	var iLeft = Math.round((screen.width  - iWidth) / 2);
	var iTop  = Math.round((screen.height - iHeight) / 2);

	var sOptions = "toolbar=no, status=no, resizable=no, dependent=yes" ;
	sOptions += ", width=" + iWidth ;
	sOptions += ", height=" + iHeight ;
	sOptions += ", left=" + iLeft ;
	sOptions += ", top=" + iTop ;

	var oWindow = window.open('script/controls/calendar.html', 'PapayaPopupWindow', sOptions);
  oWindow.linkedObject = this;
}

papayaPopupInput.prototype.openPopupColor = function() {
	// Set the browser window feature.
	var iWidth	= 280;
	var iHeight	= 240;

	var iLeft = Math.round((screen.width  - iWidth) / 2);
	var iTop  = Math.round((screen.height - iHeight) / 2);

	var sOptions = "toolbar=no, status=no, resizable=no, dependent=yes" ;
	sOptions += ", width=" + iWidth ;
	sOptions += ", height=" + iHeight ;
	sOptions += ", left=" + iLeft ;
	sOptions += ", top=" + iTop ;

	var oWindow = window.open('script/controls/color.html', 'PapayaPopupWindow', sOptions);
  oWindow.linkedObject = this;
}
papayaPopupInput.prototype.getColorData = function() {
  if (this.editField) {
    return this.editField.value;  
  }
  return '';
}
papayaPopupInput.prototype.setColorData = function(color) {
  if (color) {
    this.editField.value = color;
  }
}
papayaPopupInput.prototype.setImageData = function(src, width, height) {
  if (src) {
    this.editField.value = src;
  }
}
papayaPopupInput.prototype.setImageDataEx = function(src, width, height, scale) {
  if (src) {
    var value = src;
    value += (isNaN(width)) ? ',0' : ',' + width.toString();
    value += (isNaN(height)) ? ',0' : ',' + height.toString();
    switch (scale) {
    case 'mincrop' :
    case 'min' :
    case 'abs' :
      value += ',' + scale;
      break;
    case 'max' :
    default :
      value += ',max';       
      break;
    }
    this.editField.value = value;
  }
}

papayaPopupInput.prototype.getImageData = function() {
  if (this.editField) {
    return this.editField.value;  
  }
  return '';
}

papayaPopupInput.prototype.setPageId = function(pageId) {
  if (pageId) {
    this.editField.value = pageId;
  }
}

papayaOpenPopupHandler = function() {
  this.linkedPopup.execute();
}