stringToInteger = function (strValue, defaultValue) {
  var result = parseInt(strValue);
  if (isNaN(result)) {
    return defaultValue;
  } else {
    return result;
  }
}

//#### EMail-Parser Functions

var oEmailParser = new Object() ;

oEmailParser.ParseEMailUrl = function(emailUrl) {
	// Initializes the EMailInfo object.
	var oEMailInfo = new Object();
	oEMailInfo.Address	= '';
	oEMailInfo.Subject	= '';
	oEMailInfo.Body		= '';

	var oParts = emailUrl.match( /^([^\?]+)\??(.+)?/ );
	if (oParts)	{
		// Set the e-mail address.
		oEMailInfo.Address = oParts[1] ;

		// Look for the optional e-mail parameters.
		if (oParts[2]) {
			var oMatch = oParts[2].match(/(^|&)subject=([^&]+)/i);
			if (oMatch) oEMailInfo.Subject = unescape(oMatch[2]);

			oMatch = oParts[2].match( /(^|&)body=([^&]+)/i );
			if (oMatch) oEMailInfo.Body = unescape(oMatch[2]);
		}
	}
	return oEMailInfo ;
}

oEmailParser.CreateEMailUri = function(address, subject, body) {
	var sBaseUri = 'mailto:' + address;
	var sParams = '' ;

	if (subject.length > 0) {
		sParams = '?subject=' + escape( subject );
  }
	if (body.length > 0) {
		sParams += ( sParams.length == 0 ? '?' : '&' );
		sParams += 'body=' + escape( body );
	}
	return sBaseUri + sParams;
}